<template>
	<div class="q-pa-md q-gutter-sm">
		<q-dialog v-model="userEdit" class="dialog">
			<q-card style="width: 500px;">
				<div class="row">
					<q-card-section>
						<div class="text-h6">Update user</div>
					</q-card-section>
					<q-space />
					<q-card-section>
						<q-btn round dense icon="close" v-close-popup />
					</q-card-section>
				</div>
				<q-card-section class="q-pt-none">
					<div>Update account of {{ userName }}</div>
					<br />
					<q-input
						outlined
						v-model="email"
						label="Email"
						type="email"
						:rules="[
							(val) => !!val || 'Field is required',
							isValidEmail,
						]"
						ref="email"
					/>
					<q-input
						outlined
						type="number"
						v-model="age"
						label="Your age *"
						:rules="[
							(val) =>
								(val !== null && val !== '') ||
								'Please type your age',
							(val) =>
								(val > 0 && val < 100) ||
								'Please type a real age',
						]"
						ref="age"
					/>
					<q-input
						outlined
						v-model="birthDate"
						mask="date"
						label="Date of birth"
						:rules="[
							(val) =>
								(val !== null && val !== '') ||
								'Filled is required',
						]"
						ref="birthDate"
					>
						<template v-slot:append>
							<q-icon name="event" class="cursor-pointer">
								<q-popup-proxy
									ref="qDateProxy"
									transition-show="scale"
									transition-hide="scale"
								>
									<q-date v-model="birthDate">
										<div
											class="row items-center justify-end"
										>
											<q-btn
												v-close-popup
												label="Close"
												color="primary"
												flat
											/>
										</div>
									</q-date>
								</q-popup-proxy>
							</q-icon>
						</template>
					</q-input>
					<div class="q-pa-md q-gutter-sm">
						<q-dialog
							v-model="alertSuccess"
							persistent
							transition-show="scale"
							transition-hide="scale"
						>
							<q-card
								class="bg-green-9 text-white"
								style="width: 300px;"
							>
								<q-card-section>
									<div class="text-h6">Success</div>
								</q-card-section>

								<q-card-section class="q-pt-none">
									Successful user data update.
								</q-card-section>

								<q-card-actions
									align="right"
									class="bg-white text-teal"
								>
									<q-btn flat label="OK" v-close-popup />
								</q-card-actions>
							</q-card>
						</q-dialog>
					</div>
					<q-btn
						style="width: 100%;"
						label="Update"
						color="primary"
						type="button"
						@click="updateUserData"
					/>
				</q-card-section>
			</q-card>
		</q-dialog>
	</div>
</template>

<script>
import { mapGetters } from "vuex";
import { mapActions } from "vuex";
export default {
	data() {
		return {
			alertSuccess: false,
		};
	},
	methods: {
		// isValidString(val) {
		// 	const stringPattern = /^[a-zA-Z]+$/;
		// 	return stringPattern.test(val) || "Invalid String";
		// },
		// validate email
		isValidEmail(val) {
			const emailPattern = /^(?=[a-zA-Z0-9@._%+-]{6,254}$)[a-zA-Z0-9._%+-]{1,64}@(?:[a-zA-Z0-9-]{1,63}\.){1,8}[a-zA-Z]{2,63}$/;
			return emailPattern.test(val) || "Invalid email";
		},

		updateUserData() {
			this.$refs.email.validate();
			this.$refs.age.validate();
			this.$refs.birthDate.validate();
			if (
				!this.$refs.email.hasError &&
				!this.$refs.age.hasError &&
				!this.$refs.birthDate.hasError
			) {
				this.$axios.put(this.host + "/src/php/actions/user.php", {
					action: "edit",
					userId: this.userId,
					email: this.email,
					age: this.age,
					birthDate: this.birthDate,
				});
				this.alertSuccess = true;
			}
			this.$emit("reload");
		},
		// ...mapActions({
		// 	userName: "showcase/userName",
		// }),
	},
	computed: {
		...mapGetters({
			editForm: "showcase/userEdit",
			userName: "showcase/userName",
			userEmail: "showcase/userEmail",
			userAge: "showcase/userAge",
			userBirthDate: "showcase/userBirthDate",
			userId: "showcase/userId",
		}),
		userEdit: {
			get() {
				return this.editForm;
			},
			set(val) {
				this.$store.commit("showcase/hideUserEditForm", val);
			},
		},
		email: {
			get() {
				return this.userEmail;
			},
			set(val) {
				this.$store.commit("showcase/userEmail", val);
			},
		},
		age: {
			get() {
				return this.userAge;
			},
			set(val) {
				this.$store.commit("showcase/userAge", val);
			},
		},
		birthDate: {
			get() {
				return this.userBirthDate;
			},
			set(val) {
				this.$store.commit("showcase/userBirthDate", val);
			},
		},
	},
};
</script>
